频道栏目
首页 > 程序开发 > 移动开发 > Android > 正文
eclipse再见,android studio 新手入门教程(二)项目的导入
2016-04-19 09:04:36         来源:扬州慢的android博客  
收藏   我要投稿

上一篇博客介绍了AS的一些常用设置方法,当工具调教妥当后,自然就要开始项目的开发啦。从零开始新建一个项目,这个简单,不必多说,这篇博客会分享我从旧平台eclipse导入项目到AS的过程,以及遇到的一些问题并如何解决。开篇先粗略的提一些需要注意的地方。

结构目录

和eclipse不同,在android 视图下的项目目录分为java,res和manifests。

测试vcDvw+a05rfF18VhcHC1xMb0tq/NvLHqoaOy6b+0udm3vc7EtbWjrL+0tb3V4sO00ru+5KO6DQo8cD48aW1nIGFsdD0="mipmap文件夹" src="/uploadfile/Collfiles/20160419/2016041909044116.png" title="\" />

To avoid these display issues, apps should use the mipmap/ resource folders for launcher icons. The Android system preserves these resources regardless of density stripping, and ensures that launcher apps can pick icons with the best resolution for display.
出处:http://developer.android.com/tools/projects/index.html

大意是为了避免设备显示问题,app应该使用mipmap目录存放应用图标。所以app的启动图标应该放置在mipmap文件夹中,至于其他的用处还不是很清楚,之前也遇到过导入eclipse项目时.9图片报错,网络上有人说.9图应该放在mipmap里,但是我把.9图片放到mipmap目录后仍然不能解决我的问题,最后因为项目里.9图不多,使用AS的工具重绘后解决了问题。
 

库依赖

eclipse里添加存在本地的第三方库的方式:

- 将第三方库导入workspace

- 右键项目-android-add Library

AS里添加库的方式:

- 导入第三方库工程到project,第三方库作为一个新的module存在于project中

- File-project structure,选择项目,添加库

 

这里写图片描述

 

 

这里写图片描述

 

通过对比可以发现,AS里的project就相当于eclipse里的workspace的概念,module相当于eclipse里独立的项目。也可以发现,其实二者在依赖存在于本地的第三方库的操作上是类似的,添加jar包的操作也是一样,只要把jar包复制到lib目录下(切换到Project Files视图下会看到Lib目录),然后同样操作project structure,选择file dependency后选择依赖lib库下刚添加进的jar包即可。

但是如果是添加线上开源库的话,二者的差距就体现出来了,以往在github上看到优秀的开源库,想要应用到自己的项目中,就得先把项目下载下来,然后再添加依赖,虽然操作不繁琐,但是我渐渐发现github上越来越多的开发者都转向AS,不再单独提供eclipse上使用的版本。这个不赘述,因为想转平台,能看到这篇博客的朋友,肯定或多或少都有些同感。总之一句话:google大法好。退eclipse保平安,赶紧转AS吧。

初识gradle

在android视图gradle目录下,可以看到有多个build.gradle,其中后缀module + 项目名 的就是平时添加第三方库时需要配置的gradle文件了,以Github上CircleImageview这个开源库为示例,其github主页上有这么一段代码:

github上的导入gradle教程

我们唯一要做的,就是将这段代码拷贝到项目的gradle-dependencies语句块下

 

gradle

 

然后点击工具栏图标

 

Sync Now

 

之后gradle就会自动从远程仓库下载该库所需要的jar包等依赖文件,一键搞定,简直不要太爽!

然而gradle爽是爽,但是后续也会提到在导入项目时因为gradle版本不同而出现一些麻烦的地方。

导入Eclipse项目

上面说了如何依赖库,但有些朋友需要开发旧项目而不是新建项目,光导入eclipse项目时报的错都够喝一壶了,更别提如何正确的依赖库,所以接下来就示范一下如何正确的导入eclipse的项目。不同项目会出现的问题不尽相同,这里权且算是抛砖引玉,给大家提供一些解决问题的思路。

首先在eclipse里,右键-export,导出项目的gradle目录

 

导出gradle

 

选中要导出的项目,一路next,最后一步建议force overriding一栏打勾(我理解为是已存在gradle文件,选中的话将强制重写),导出成功后会出现提示:

 

导出成功提示

 

请选择以下目录: …build.gradle,不要导入Eclipse项目本身!

别人我不知道,反正我是照着这个提示在AS里导入目录下的build.gradle文件,然后结果就把整个工作目录里的项目都给导入了(╯‵□′)╯︵┻━┻。

什么鬼!一定是我打开的方式不对!后来在AS里尝试

 

导入1

 

 

导入2

 

导入时选择项目本身,而不是build.gradle文件,这才导入成功。

但是不要高兴的太早,这才只是麻烦的开始。
 

问题1 找不到类

 

问题1

 

解决办法:找不到相关的类,定位到代码,发现是recyclerview的一些类报错,于是猜测是因为依赖的问题,在项目依赖库里添加recyclerview库,问题解决!

 

添加recyclerview库

 

问题2 库重复依赖

库重复依赖

错误提示中可以看到是因为有多个同名的库报错,因为我从eclipse导出项目时就自带了supportV7的recyclerview的库,而我刚刚有添加了新的recyclerview库,所以二者重复依赖了,解决办法很简单,去除之前的recyclerview依赖即可,问题解决!

问题3 清单文件合并出错 Manifest merger failed

清单文件合并出错

整个报错信息是这样的:

java.lang.RuntimeException: Manifest merger failed : uses-sdk:minSdkVersion 1 cannot be smaller than version 7 declared in library [com.android.support:appcompat-v7:23.2.1] D:\studioCode\NewOneBuy\lib_CircleImageView\build\intermediates\exploded-aar\com.android.support\appcompat-v7\23.2.1\AndroidManifest.xml
Suggestion: use tools:overrideLibrary=”android.support.v7.appcompat” to force usage

可以看到是是因为circleimageview的minSdkVersion低于appcompatV7定义的version而导致的清单文件合并出错,提示中也告诉了我们解决方法,只要在circleimageview的清单文件中配置好即可。

清单文件配置

问题4 程序包不存在

程序包不存在

这个问题也简单,定位到相关的代码,使用快捷键:ctrl+alt+O, 去除无效的导包即可。
 

问题5 重复文件(jar包) Duplicate files

 

重复jar包

 

提示信息中也标明了是在File1,File2中两个不同的库含有相同的文件(jar包)导出出错,在prodect视图下查看lib目录,可以看到确实是有重复文件

 

重复文件

 

解决问题也很简单:删除jar包,去除依赖即可

 

去除依赖

问题6 finished with non-zero exit value 2

What went wrong:
Execution failed for task ‘:newOneBuy:transformClassesWithDexForDebug’.
com.android.build.api.transform.TransformException: com.android.ide.common.process.ProcessException: java.util.concurrent.ExecutionException: com.android.ide.common.process.ProcessException: org.gradle.process.internal.ExecException: Process ‘command ‘C:\Program Files (x86)\Java\jdk1.8.0_60\bin\java.exe” finished with non-zero exit value 2

这个没看懂错误原因,但是最后通过在项目的module的build.gradle里修改配置后解决了问题,但是不知其所以然。

 defaultConfig {
        applicationId "com.example.newonebuy"
        minSdkVersion 11
        targetSdkVersion 21
        multiDexEnabled true
    }

其实在导入之前,看着一行又一行红彤彤的报错我的内心是崩溃的,但其实只要耐着性子根据提示逐个排查,遇到不懂的就谷歌,毕竟这只是些很初级的问题,总是会解决的。最近生活里的烦心事不少,在码代码时渐渐能感觉到一种很奇妙的感情,在代码的世界里,1是1,0是0,只要你愿意付出心血,错误总会消失,bug总会修复,而不像现实世界,很多事情人心难测,即便人心可测也本心难移,很多时候会感觉到深深的无力和无可奈何。
不多扯了,这篇先分享这些吧。下篇博客会分享一下在AS上使用github进行版本控制的一些事,还有在导入module时因为gradle版本而导致的一些问题。另外最近看到kotlin这门新兴的语言似乎挺有意思,等到下个项目尝试一下看kotlin能否高效、有效的解决一些问题,如果后面有什么收获,也有写出来分享的。有一分热发一分光,写的文章只要有一个人看到,解决了一个人的问题,那文章就有价值。即使都没人看,那就当做写给自己,作为对所思所学的一个总结吧。
但行善事,莫问前程。愿世界和平,愿某人喜乐平安。

点击复制链接 与好友分享!回本站首页
上一篇:Android加密算法
下一篇:Android仿联系人列表分组悬浮列表,PinnedHeaderListView源码解析
相关文章
图文推荐
点击排行

关于我们 | 联系我们 | 广告服务 | 投资合作 | 版权申明 | 在线帮助 | 网站地图 | 作品发布 | Vip技术培训 | 举报中心

版权所有: 红黑联盟--致力于做实用的IT技术学习网站